/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package Vista;

import Negocio.EvaluadorExpresion;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author Jose Flórez
 */
public class GUICalculadora extends javax.swing.JFrame {
    
    EvaluadorExpresion evaluador;
    boolean checkPre;
    boolean checkPro;

    /**
     * Creates new form EvaluadorExpresiones
     */
    public GUICalculadora() {
        initComponents();
        this.evaluador = new EvaluadorExpresion();
        this.checkPre = false;
        this.checkPro = false;
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        txtExpresion = new javax.swing.JTextField();
        btnRegistrar = new javax.swing.JButton();
        lbResultado = new javax.swing.JLabel();
        btnEvaluar = new javax.swing.JButton();
        lbRPrefijo = new javax.swing.JLabel();
        ckPrefijo = new javax.swing.JCheckBox();
        ckPosfijo = new javax.swing.JCheckBox();
        lbRPosfijo = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        jLabel1.setText("Expresión Infija");

        txtExpresion.setToolTipText("Ingrese la expresión a evaluar");
        txtExpresion.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                txtExpresionActionPerformed(evt);
            }
        });

        btnRegistrar.setText("Registrar");
        btnRegistrar.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                btnRegistrarMouseClicked(evt);
            }
        });
        btnRegistrar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnRegistrarActionPerformed(evt);
            }
        });

        lbResultado.setBackground(new java.awt.Color(223, 223, 223));
        lbResultado.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lbResultado.setText("<<Resultado operación>>");

        btnEvaluar.setText("Evaluar");
        btnEvaluar.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        btnEvaluar.setEnabled(false);
        btnEvaluar.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                btnEvaluarMouseClicked(evt);
            }
        });
        btnEvaluar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnEvaluarActionPerformed(evt);
            }
        });

        lbRPrefijo.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);

        ckPrefijo.setText("Prefijo:");
        ckPrefijo.setEnabled(false);
        ckPrefijo.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                ckPrefijoMouseClicked(evt);
            }
        });
        ckPrefijo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ckPrefijoActionPerformed(evt);
            }
        });

        ckPosfijo.setText("Posfijo:");
        ckPosfijo.setEnabled(false);
        ckPosfijo.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                ckPosfijoMouseClicked(evt);
            }
        });
        ckPosfijo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ckPosfijoActionPerformed(evt);
            }
        });

        lbRPosfijo.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);

        jLabel5.setFont(new java.awt.Font("Tahoma", 0, 12)); // NOI18N
        jLabel5.setText("Power by: Jose Flórez 1151999");

        jLabel6.setFont(new java.awt.Font("Tahoma", 1, 18)); // NOI18N
        jLabel6.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel6.setText("Evaluador de Expresiones");
        jLabel6.setToolTipText("");

        jLabel7.setIcon(new javax.swing.ImageIcon(getClass().getResource("/Vista/media/logo.png"))); // NOI18N

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(20, 20, 20)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel1)
                    .addComponent(jLabel7, javax.swing.GroupLayout.PREFERRED_SIZE, 92, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(btnRegistrar)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(btnEvaluar))
                    .addComponent(txtExpresion, javax.swing.GroupLayout.DEFAULT_SIZE, 344, Short.MAX_VALUE)
                    .addComponent(jLabel6, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addGap(0, 0, Short.MAX_VALUE))
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(108, 108, 108)
                        .addComponent(lbResultado, javax.swing.GroupLayout.PREFERRED_SIZE, 346, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                        .addGap(44, 44, 44)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(ckPosfijo)
                                .addGap(18, 18, 18)
                                .addComponent(lbRPosfijo, javax.swing.GroupLayout.PREFERRED_SIZE, 238, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(ckPrefijo)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addComponent(lbRPrefijo, javax.swing.GroupLayout.PREFERRED_SIZE, 238, javax.swing.GroupLayout.PREFERRED_SIZE)))))
                .addContainerGap(58, Short.MAX_VALUE))
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addGap(0, 0, Short.MAX_VALUE)
                .addComponent(jLabel5)
                .addGap(151, 151, 151))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel7, javax.swing.GroupLayout.PREFERRED_SIZE, 85, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(22, 22, 22)
                        .addComponent(jLabel6)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(txtExpresion, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(btnRegistrar)
                    .addComponent(btnEvaluar))
                .addGap(32, 32, 32)
                .addComponent(lbResultado, javax.swing.GroupLayout.PREFERRED_SIZE, 42, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lbRPrefijo)
                    .addComponent(ckPrefijo))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lbRPosfijo)
                    .addComponent(ckPosfijo))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 34, Short.MAX_VALUE)
                .addComponent(jLabel5)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void txtExpresionActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_txtExpresionActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_txtExpresionActionPerformed

    private void ckPrefijoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ckPrefijoActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_ckPrefijoActionPerformed

    private void ckPosfijoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ckPosfijoActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_ckPosfijoActionPerformed

    private void btnRegistrarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnRegistrarActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_btnRegistrarActionPerformed

    private void btnRegistrarMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_btnRegistrarMouseClicked
        // TODO add your handling code here:
        String expresion;
        
        expresion = txtExpresion.getText();
        
        if(expresion.equals("")) {
            javax.swing.JOptionPane.showMessageDialog(this, "Primero debes llenar el campo de la expresión", "AVISO!", javax.swing.JOptionPane.INFORMATION_MESSAGE);
            txtExpresion.requestFocus();
        } else {
            try {
                this.evaluador.setExpresion(expresion);
                btnEvaluar.setEnabled(true);
            } catch (Exception e) {
                System.err.println(e.getMessage());
                javax.swing.JOptionPane.showMessageDialog(this, e.getMessage(), "AVISO!", javax.swing.JOptionPane.INFORMATION_MESSAGE);
                txtExpresion.requestFocus();
            }
        }
    }//GEN-LAST:event_btnRegistrarMouseClicked

    private void btnEvaluarMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_btnEvaluarMouseClicked
        // TODO add your handling code here:
        String resultado;
        try {
            resultado = this.evaluador.getEvaluarExpresion();
            lbResultado.setText(resultado +  "");
            ckPosfijo.setEnabled(true);
            ckPrefijo.setEnabled(true);
        } catch (Exception ex) {
            Logger.getLogger(GUICalculadora.class.getName()).log(Level.SEVERE, null, ex);
            javax.swing.JOptionPane.showMessageDialog(this, "Parece que algo ha salido mal, intentalo de nuevo", "AVISO!", javax.swing.JOptionPane.INFORMATION_MESSAGE);
            txtExpresion.requestFocus();
        }
        
    }//GEN-LAST:event_btnEvaluarMouseClicked

    private void ckPrefijoMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_ckPrefijoMouseClicked
        try {
            // TODO add your handling code here:
            if(!this.checkPre){
                lbRPrefijo.setText(this.evaluador.getPrefijo());
                this.checkPre = true;
            } else {
                lbRPrefijo.setText("");
                this.checkPre = false;
            }
        } catch (Exception ex) {
            Logger.getLogger(GUICalculadora.class.getName()).log(Level.SEVERE, null, ex);
            javax.swing.JOptionPane.showMessageDialog(this, "Parece que algo ha salido mal, intentalo de nuevo", "AVISO!", javax.swing.JOptionPane.INFORMATION_MESSAGE);
            txtExpresion.requestFocus();
        }
    }//GEN-LAST:event_ckPrefijoMouseClicked

    private void ckPosfijoMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_ckPosfijoMouseClicked
        // TODO add your handling code here:
        if(!this.checkPre){
            lbRPosfijo.setText(this.evaluador.getPosfijo());
            this.checkPre = true;
        } else {
            lbRPrefijo.setText("");
            this.checkPre = false;
        }
    }//GEN-LAST:event_ckPosfijoMouseClicked

    private void btnEvaluarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnEvaluarActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_btnEvaluarActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(GUICalculadora.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(GUICalculadora.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(GUICalculadora.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(GUICalculadora.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new GUICalculadora().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnEvaluar;
    private javax.swing.JButton btnRegistrar;
    private javax.swing.JCheckBox ckPosfijo;
    private javax.swing.JCheckBox ckPrefijo;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel lbRPosfijo;
    private javax.swing.JLabel lbRPrefijo;
    private javax.swing.JLabel lbResultado;
    private javax.swing.JTextField txtExpresion;
    // End of variables declaration//GEN-END:variables
}
